/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasPrivatelinkEndpointsServiceAdlConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.12.1/docs/data-sources/privatelink_endpoints_service_adl#id DataMongodbatlasPrivatelinkEndpointsServiceAdl#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.12.1/docs/data-sources/privatelink_endpoints_service_adl#project_id DataMongodbatlasPrivatelinkEndpointsServiceAdl#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasPrivatelinkEndpointsServiceAdlLinks {
}
export declare function dataMongodbatlasPrivatelinkEndpointsServiceAdlLinksToTerraform(struct?: DataMongodbatlasPrivatelinkEndpointsServiceAdlLinks): any;
export declare class DataMongodbatlasPrivatelinkEndpointsServiceAdlLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasPrivatelinkEndpointsServiceAdlLinks | undefined;
    set internalValue(value: DataMongodbatlasPrivatelinkEndpointsServiceAdlLinks | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataMongodbatlasPrivatelinkEndpointsServiceAdlLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasPrivatelinkEndpointsServiceAdlLinksOutputReference;
}
export interface DataMongodbatlasPrivatelinkEndpointsServiceAdlResults {
}
export declare function dataMongodbatlasPrivatelinkEndpointsServiceAdlResultsToTerraform(struct?: DataMongodbatlasPrivatelinkEndpointsServiceAdlResults): any;
export declare class DataMongodbatlasPrivatelinkEndpointsServiceAdlResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasPrivatelinkEndpointsServiceAdlResults | undefined;
    set internalValue(value: DataMongodbatlasPrivatelinkEndpointsServiceAdlResults | undefined);
    get comment(): string;
    get endpointId(): string;
    get providerName(): string;
    get type(): string;
}
export declare class DataMongodbatlasPrivatelinkEndpointsServiceAdlResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasPrivatelinkEndpointsServiceAdlResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.12.1/docs/data-sources/privatelink_endpoints_service_adl mongodbatlas_privatelink_endpoints_service_adl}
*/
export declare class DataMongodbatlasPrivatelinkEndpointsServiceAdl extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_privatelink_endpoints_service_adl";
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.12.1/docs/data-sources/privatelink_endpoints_service_adl mongodbatlas_privatelink_endpoints_service_adl} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasPrivatelinkEndpointsServiceAdlConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasPrivatelinkEndpointsServiceAdlConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _links;
    get links(): DataMongodbatlasPrivatelinkEndpointsServiceAdlLinksList;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasPrivatelinkEndpointsServiceAdlResultsList;
    get totalCount(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
